/******************************************************************************
*******************************************************************************

	Space Impakto DS
	relminator
	http://rel.betterwebber.com


	Cviper class


*******************************************************************************
******************************************************************************/

#include <nds.h>

#include "Cglsprite.h"
#include "Cobject.h"
#include "Cshot.h"
#include "Coption.h"
#include "Cenemy.h"


#ifndef Cviper__H
#define Cviper__H

#define  START_X -100
#define  MAX_VIPER_BULLETS 32
#define  MAX_VIPER_SHOT_DELAY 6
#define  VIPER_SHOT_SPEED 7
#define  MAX_OPTIONS 2
#define  FP_PI 16384 


enum E_VIPER_DIRECTION
{
	E_NEUTRAL = 0,
	E_UP,
	E_DOWN,
	E_LEFT,
	E_RIGHT
};

enum E_VIPER_STATE
{

	E_ALIVE 		= (1 << 0),				// 
	E_DEAD 			= (1 << 1),
	E_INVINCIBLE 	= (1 << 2),				// after death or stage start and end
	E_LOCKED 		= (1 << 3)				// stage start/end
	
};

class Cviper : public Cobject
{
	public:
	
	Cviper();
	void start_shots(s32 start_x, s32 start_y);
	void start_wave_shots(s32 start_x, s32 start_y);
	void do_shots();
	void control(Cenemy &target);
	void update();
	void initialize();
	void newlife();
	void render(Cglsprite *sprites);
	void draw_aabb(Cgl2d &gl2d);
	
	
	
	
	int 				key_held;		// for replay
	int					key_down;		// ditto
	
	int					state;
	
	int  				shot_delay;
	int 				option_shot_delay;
	
	E_VIPER_DIRECTION	direction;
	
	int 				jet_counter;
	int					jet_frame;
	
	Cshot				shots[MAX_VIPER_BULLETS];
	
	Coption				options[MAX_OPTIONS];
	
};


#endif

