/******************************************************************************
*******************************************************************************

	Space Impakto DS
	relminator (Richard Eric M. Lope BSN RN)
	http://rel.betterwebber.com


	main() entry point
	
	* Ditched the old oam based renderer
	* Now uses the 3d core to render 2d sprites as well as 3d stuff
	* Will probably make use of the 2d core to render explosions and fonts

Notes:(06/4/10)
	1. enemy (x,y,dx,dy) as now all .12 FP (nneds to make an ADD_ENEMY MACRO to
			automate single/int const to .12 FP )
	2. Add special explosions
	3. viper, option, shots (x,y,dx,dy) as not .12 FP
	4. vector<> or list<>?
 
*******************************************************************************
******************************************************************************/


#include <nds.h>
#include <stdio.h>
#include <math.h>
#include <string.h>

#include "Cglsprite.h"
#include "Cgl2d.h"

#include "cearn_atan.h"
#include "Caabb.h"
#include "Cvertexbuffer.h"
#include "Csupershape.h"
#include "Cspline.h"
#include "Cobject.h"
#include "Cexplosion.h"
#include "Cbullet.h"
#include "Cenemy.h"
#include "Cshot.h"
#include "Coption.h"
#include "Cviper.h"



// GRIT headers
#include "main_sprites.h"
#include "enemies.h"
#include "organ16.h"

// Texture packer headers
#include "uvcoord_main_sprites.h"
#include "uvcoord_enemies.h"


#define  MAX_SHAPES 4

#define  MAX_POINTS 8
#define  FP_PI 16384 

#define NUM_BULLETS 256


//const int FP_PI = 2 << 13;
const int MAX_SPAWN_DELAY = 1;
const int BULLET_SPEED = 0.75 * (1 << 12);


int bullets_on_screen = 0;






class Cbullet2 : public Cobject
{
	public:
	void update(int &bulletsonscreen);
};


void Cbullet2::update(int &bulletsonscreen)
{
	x += dx;
	y += dy;
	
	if ( ((x >> 12) < -8) || ((x >> 12) > SCREEN_WIDTH) || ((y >> 12) < -8) || ((y >> 12) > SCREEN_HEIGHT)) 
	{
		active = false;
		bulletsonscreen--;
	}
	
	resolve_aabb_f32();
	box.shrink(2600);

	
	
	// animate 
	if ( anim_counter >= anim_delay)
	{
		frame++;
		if ( frame >= num_frames)
			frame = 0;
		
		anim_counter = -1;
	}

	// inc counter
	anim_counter++;
	
}


u16 startTimer(int timer)
{
	TIMER_CR(timer) = 0;
	TIMER_DATA(0) = 0;
	TIMER_CR(timer) = TIMER_DIV_1024 | TIMER_ENABLE;
	return TIMER_DATA(0);
}

#define get_timer(timer) (TIMER_DATA(timer))


/******************************************************************************
*******************************************************************************
	MAIN entry point


*******************************************************************************
******************************************************************************/


const int GRID_RINGS = 2;
const int GRID_BANDS = 2;
const int GRID_WIDTH = 15;
const int GRID_HEIGHT = 12;

// some constants to make
// our quadric
const int RINGS = 8;
const int BANDS = 8;
const float RADIUS = 1.0f;



void init_gl_screen();
void draw_grid();
void init_super_shapes(Csupershape shape[], Cvertexbuffer *supashape[]);
void init_shape_vbs( Cvertexbuffer *supershape_vb[]);
void draw_3d();

Cglsprite main_sprites[MAIN_SPRITES_NUM_IMAGES];	//  number of frames
Cglsprite enemies_sprites[ENEMIES_NUM_IMAGES];		


Cgl2d gl2d;

Cenemies enemies;
Cviper viper;
Cexplosion explosions;


Cvertexbuffer *grid_vb;
Cvertexbuffer *super_shape_vb[4];

Csupershape shapes[MAX_SHAPES];

Cbullet2 shots[NUM_BULLETS];
Cbullet2 shots2[NUM_BULLETS];


void check_collisions(Cviper &viper, Cenemies &en, Cexplosion &ex)
{
	for(int i=0; i<MAX_VIPER_BULLETS; i++)
	{
		if (viper.shots[i].active)
		{
			for (int j = 0; j < MAX_ENEMIES; j++ )
			{
				if (en.enemy[j].active)
				{
					if (viper.shots[i].box.intersects(en.enemy[j].box))
					{
						viper.shots[i].active = false;
						en.enemy[j].draw_mode = E_COLOR;
						en.enemy[j].hit_cooldown = 2;
						en.enemy[j].hp -= viper.shots[i].energy;
						// check if hp is < 0
						if (en.enemy[j].hp < 0)
						{
							ex.add(en.enemy[j].deathID, en.enemy[j].x, en.enemy[j].y, -1 << 12, 0);
							en.kill(j);
						}
						// shot explosion add needs .12 FP
						ex.add(EX_TINY_1, viper.shots[i].x << 12, viper.shots[i].y << 12, 3 << 12,0);
						break;
					}  // intersect 
				}  // enemy active
			}	// enemies
		}	
	}	// viper shots
}


void check_viper_collisions(Cviper &viper, Cbullet2 *bullets, Cexplosion &ex)
{
	for (int i=0; i < NUM_BULLETS; i++)
	{
		if (bullets[i].active)
		{
			if (viper.box.intersects(bullets[i].box))
			{
				bullets[i].active = false;
				ex.add(EX_SMALL_1, bullets[i].x, bullets[i].y, bullets[i].dx >> 1,bullets[i].dy >> 1);
			}
		}
	}
}

int spawndelay;
int turret_angle = 0;
int turret_angle2 = 0; 
int turret_radius = 10;
int turret_x = 128 << 12;
int turret_y = 96 << 12;

u16 current_time = startTimer(0);

int main()
{

	

	
	
	grid_vb = init_grid (GRID_RINGS, GRID_BANDS, GRID_WIDTH,GRID_HEIGHT,8,8);
	init_shape_vbs(super_shape_vb);
	init_super_shapes(shapes, super_shape_vb);
	
	
	videoSetMode(MODE_5_3D);
	
	
	consoleDemoInit();
	
	iprintf("\x1b[1;1HSpace Impakto DS");
	iprintf("\x1b[2;1HRelminator");
	iprintf("\x1b[3;1Hhttp://rel.betterwebber.com");
	
	iprintf("\x1b[5;1HControls:");
	iprintf("\x1b[6;1HArrows->move");
	iprintf("\x1b[7;1HKey A->Fire weapons");
	iprintf("\x1b[8;1HKey B->Toggle AABB's");
	iprintf("\x1b[9;1HKey X->Toggle bullets");
	iprintf("\x1b[10;1HKey Y->Toggle 3d");
	iprintf("\x1b[11;1HKey SELECT->New ship");
	
	
	//gl2d_init();
	init_gl_screen();
	
	
	vramSetBankA(VRAM_A_TEXTURE);		// 128 kb -> main_sprites(64kb) and enemies(64kb) 
	vramSetBankB(VRAM_B_TEXTURE);		// 64x64 floor/ceiling
	
	// main sprites
	int main_sprites_textureID;  
	gl2d.load_texture(main_sprites_textureID,GL_RGB256, TEXTURE_SIZE_256 , TEXTURE_SIZE_256, (u8*)main_spritesBitmap);

	// enemies
	int enemies_textureID;  
	gl2d.load_texture(enemies_textureID,GL_RGB256, TEXTURE_SIZE_256 , TEXTURE_SIZE_256, (u8*)enemiesBitmap);

	// load global pal
	// texture pal in VRAM_E?
	gluTexLoadPal(main_spritesPal, 512,GL_RGB256);

		
	// init sprites
	gl2d.init_sprites(main_sprites, MAIN_SPRITES_NUM_IMAGES, main_sprites_texcoords, main_sprites_textureID);
	
	//  enemies
	gl2d.init_sprites(enemies_sprites, ENEMIES_NUM_IMAGES, enemies_texcoords, enemies_textureID);
	
	
	grid_vb->load_texture((u8*)organ16Bitmap);
	
	//TEMP!!! copy textures (needs a copy texture funk for Cvertexbuffer and decrease text sizes to 64x64)
	super_shape_vb[0]->load_texture((u8*)organ16Bitmap);
	super_shape_vb[1]->i_texture_ID = super_shape_vb[0]->i_texture_ID;
	super_shape_vb[2]->i_texture_ID = grid_vb->i_texture_ID;
	super_shape_vb[3]->i_texture_ID = grid_vb->i_texture_ID;
	
	
	for (int i=0; i<NUM_BULLETS; i++ )
	{
	
		shots[i].active = false;
		shots[i].start_frame = 54;
		shots[i].init(main_sprites[shots[i].start_frame].width, main_sprites[shots[i].start_frame].height, 4);
		shots[i].frame = i & 3;
		
		shots2[i].active = false;
		shots2[i].start_frame = 58;
		shots2[i].init(main_sprites[shots2[i].start_frame].width, main_sprites[shots2[i].start_frame].height, 8);
		shots2[i].frame = i & 7;
	}
	
	
	viper.initialize();
	
	
	enemies.num_enemies = 0;
	enemies.add_wave_amoeba(7, enemies_sprites);
	
	enemies.add_wave_rotator_u(8, enemies_sprites);
	enemies.add_wave_rotator_d(8, enemies_sprites);
	
	enemies.add_wave_wavers_u(10, 70, enemies_sprites);
	enemies.add_wave_wavers_d(10, 192-80, enemies_sprites);
	
	
	
	bool show_boxes = false;
	bool show_3d = true;
	bool show_bullets = true;
	int total_frame = 0;
	int frame = 0;
	//int key;
	
	viper.newlife();
	
	while(1)
	{
	
	
		total_frame++;
		frame = (frame + 64) & 32767;
		
		// temp
		if ( (total_frame & 127) == 0 ) 
		{
			int randy = qran_range(0, 4);
			int num_enemies = qran_range(6, 10);
			int y_loc = qran_range(0, 180);
			switch (randy)
			{
				case 1:
					enemies.add_wave_amoeba(num_enemies, enemies_sprites);
					break;
					
				case 2:
					enemies.add_wave_rotator_u(num_enemies, enemies_sprites);
					enemies.add_wave_rotator_d(num_enemies, enemies_sprites);
					break;
					
				case 3:
					enemies.add_wave_wavers_u(num_enemies, y_loc, enemies_sprites);
					enemies.add_wave_wavers_d(num_enemies, 192-y_loc, enemies_sprites);
					break;
					
				default:
					enemies.add_wave_wavers_u(num_enemies, y_loc, enemies_sprites);
					
			}
		}
		// end temp
		
		scanKeys();
		viper.key_down = keysDown();
		viper.key_held = keysHeld();
		
		// use keysDown to toggle collision AABB's
		if(viper.key_down & KEY_B) show_boxes = !show_boxes;
		if(viper.key_down & KEY_Y) show_3d = !show_3d;
		if(viper.key_down & KEY_X) show_bullets = !show_bullets;
		
		if(viper.key_down & KEY_SELECT) viper.newlife();
		
		if(viper.key_down & KEY_START);
		{
			
			//while( !( key & KEY_START) )
			//{
			//	key = keysDown();
			//}
		}
		
		// play with sine/cosine addition to make some funky movements
		turret_x = (240 << 12) + ((cosLerp(frame*2) + sinLerp(frame*5)) * 6);
		turret_y = (96 << 12) + ((sinLerp(-frame*3) + sinLerp(frame*4)) * 40);
		
		spawndelay--;
		if (spawndelay < 0) 
		{
			turret_angle += 1024;
			turret_angle2 -= 512;
			spawndelay = MAX_SPAWN_DELAY;
        
			for (int j= 0; j < 4; j++)
			{
				for (int i=0; i < NUM_BULLETS; i++)
				{
					if (!shots[i].active)
					{
						int angle = turret_angle + (j*8192);
						shots[i].x = turret_x + turret_radius*cosLerp(angle); //12
						shots[i].y = turret_y + turret_radius*sinLerp(angle); //12
						shots[i].dx = (cosLerp(angle) * BULLET_SPEED) >> 12;  //12
						shots[i].dy = (sinLerp(angle) * BULLET_SPEED) >> 12;  //12
						shots[i].active = true;
						shots[i].frame = 0;
						bullets_on_screen++;
						break;
					}
					
				}    

				for (int i=0; i < NUM_BULLETS; i++)
				{
					
					if (!shots2[i].active)
					{
						int angle = turret_angle2 - (j*8192);
						shots2[i].x = turret_x + turret_radius*cosLerp(angle); //12
						shots2[i].y = turret_y + turret_radius*sinLerp(angle); //12
						shots2[i].dx = (cosLerp(angle) * BULLET_SPEED) >> 12;  //12
						shots2[i].dy = (sinLerp(angle) * BULLET_SPEED) >> 12;  //12
						shots2[i].active = true;
						shots2[i].frame = 0;
						bullets_on_screen++;
						break;
					}
				}
			}
		}
		
		for (int i=0; i < NUM_BULLETS; i++)
		{
			if (shots[i].active) shots[i].update(bullets_on_screen);
			if (shots2[i].active) shots2[i].update(bullets_on_screen);
		}	
		
		
		
		check_collisions(viper, enemies, explosions);
		
		enemies.update();	
		
		viper.control(enemies.enemy[6]);
		viper.update();	
		
		check_viper_collisions(viper, shots, explosions);
		check_viper_collisions(viper, shots2, explosions);
		
		explosions.update();
		
		// start 3d mode
		
		if (show_3d)
			draw_3d();
		
		// start 2d mode
		gl2d.start();
			
			
			
			// needs to be called before texturing
			// or sprite gets blended by last glcolor call
			glColor(ARGB16(1,31,31,31)); 
			
			if (show_bullets)
			{
				for (int i=0; i < NUM_BULLETS; i++)
				{
					if (shots[i].active) main_sprites[shots[i].start_frame + shots[i].frame].render(shots[i].x >> 12, shots[i].y >> 12);
					if (shots2[i].active) main_sprites[shots2[i].start_frame + shots2[i].frame].render(shots2[i].x >> 12, shots2[i].y >> 12);
				}
			}
			
			gl2d.increase_depth();
			
			enemies.draw(enemies_sprites);
			
			gl2d.increase_depth();
			
			viper.render(main_sprites);
			
			gl2d.increase_depth();
			
			explosions.draw(main_sprites);
			
			
			
			// stretch sprite test
			gl2d.increase_depth();
			
			//int length = main_sprites[36].width + ((abs(sinLerp(frame)) * 150)>>12);
			//main_sprites[36].stretch_h(10, 100, length);
			//
			//length = main_sprites[70].width + ((abs(cosLerp(frame*2)) * 170)>>12);
			//main_sprites[70].stretch_h(10, 180, length);
			
			
			// unbind texture
			
			if (show_boxes)
			{
				gl2d.disable_texture();
				
				// draw collision boxes
				// enemies
				enemies.draw_aabb(gl2d);
				
				viper.draw_aabb(gl2d);
				
				
				// bullet rel
				if (show_bullets)
				{
					for (int i=0; i < NUM_BULLETS; i++)
					{
						if (shots[i].active)
						{
							int x1 = shots[i].box.x1;
							int y1 = shots[i].box.y1;
							int x2 = shots[i].box.x2;
							int y2 = shots[i].box.y2;
							
							gl2d.box(x1, y1, x2, y2, ARGB16(1,31,0,0));
							
						}
						
						if (shots2[i].active) 
						{
							int x1 = shots2[i].box.x1;
							int y1 = shots2[i].box.y1;
							int x2 = shots2[i].box.x2;
							int y2 = shots2[i].box.y2;
							
							gl2d.box(x1, y1, x2, y2, ARGB16(1,0,31,0));
						}
					}
				}		// show bullets
			}			// end show_boxes
			
		gl2d.end();
		
		
		
		
	
		glFlush(0);

		swiWaitForVBlank();
		
		//consoleClear();
		iprintf("\x1b[16;1HBullets = %i         ", bullets_on_screen);
		iprintf("\x1b[17;1HTimer = %i           ", get_timer(0) - current_time);
		iprintf("\x1b[18;1HEnemies = %i         ", enemies.num_enemies);
		iprintf("\x1b[19;1HTrame = %i           ", total_frame);
	}

	return 0;
	
}



void init_gl_screen()
{

	// initialize gl
	glInit();
	
	//enable textures
	glEnable(GL_TEXTURE_2D);
	
	// enable antialiasing
	glEnable(GL_ANTIALIAS);
		
	// setup the rear plane
	glClearColor(0,0,0,31); // BG must be opaque for AA to work
	glClearPolyID(63); // BG must have a unique polygon ID for AA to work
	
	glClearDepth(GL_MAX_DEPTH);

	//this should work the same as the normal gl call
	glViewport(0,0,255,191);
	
	
	//any floating point gl call is being converted to fixed prior to being implemented
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(70, 256.0 / 192.0, 1, 200);
	
	gluLookAt(	0.0, 0.0, 1.0,		//camera possition 
				0.0, 0.0, 0.0,		//look at
				0.0, 1.0, 0.0);		//up

	glMaterialf(GL_AMBIENT, RGB15(31,31,31));
	glMaterialf(GL_DIFFUSE, RGB15(31,31,31));
	glMaterialf(GL_SPECULAR, BIT(15) | RGB15(31,31,31));
	glMaterialf(GL_EMISSION, RGB15(31,31,31));

	//ds uses a table for shinyness..this generates a half-ass one
	glMaterialShinyness();

	//not a real gl function and will likely change
	glPolyFmt(POLY_ALPHA(31) | POLY_CULL_BACK);
}

void draw_grid()
{
	static s32 text_off=0;

		// floor
	glPushMatrix();

		glTranslate3f32(0, -1 << 12, -2 << 12);		
		glRotateXi(inttof32(244));
		
		grid_vb->render(text_off,text_off,true);
		
	glPopMatrix(1);
	
	// ceiling
	glPushMatrix();

		glTranslate3f32(0, 1 << 12, -2 << 12);
		glRotateXi(inttof32(180));
		
		grid_vb->render(text_off,text_off,true);
	
	glPopMatrix(1);
		
	text_off = (text_off+64) & 4095;

}

void init_super_shapes(Csupershape shape[], Cvertexbuffer *supashape[])
{
	
	for (int i=0; i<MAX_SHAPES; i++)
	{
		shape[i].ps_shape = supashape[i];
		
		shape[i].x = 6 << 12;
		shape[i].y = (-1 + qran_range(0, 2)) << 12;
		shape[i].z = (-4 + qran_range(0, 4)) << 12;
	
		shape[i].x_angle = rand();
		shape[i].y_angle = rand();
		shape[i].z_angle = rand();
		
			
		shape[i].speed = qran_range(64, 256);
		
		shape[i].wait_value = (rand() % 15 ) * 60;
		shape[i].wait_counter = 0;
		shape[i].active = false;
		
		
	}

}

void init_shape_vbs( Cvertexbuffer *supershape_vb[])
{

	float a,b,m,n1,n2,n3;
	
	a = 1;
	b = 1;
	m = 4;
	n1 = 0.3;
	n2 = 1.0;
	n3 = 1.0;
	
	
	
	
	supershape_vb[0] = init_super_shape(	
										RINGS,
										BANDS,
										RADIUS,
										2,
										2,
										a,
										b,
										m,
										n1,
										n2,
										n3
											);
	
	a = 5.784;
	b = 1.436;
	m = 8.14;
	n1 = 5.867;
	n2 = -0.630;
	n3 = 15.179;
	
	supershape_vb[1] = init_super_shape(	
										RINGS,
										BANDS,
										RADIUS,
										2,
										2,
										a,
										b,
										m,
										n1,
										n2,
										n3
											);
											
	a = -5.784;
	b = -1.436;
	m = 8.14;
	n1 = 7.867;
	n2 = -0.630;
	n3 = -12.179;
	
	supershape_vb[2] = init_super_shape(	
										RINGS,
										BANDS,
										RADIUS,
										2,
										2,
										a,
										b,
										m,
										n1,
										n2,
										n3
											);

	a = 1;
	b = 3;
	m = 1;
	n1 = 0.3;
	n2 = 1.0;
	n3 = 1.0;
	
	supershape_vb[3] = init_super_shape(	
										RINGS,
										BANDS,
										RADIUS,
										2,
										2,
										a,
										b,
										m,
										n1,
										n2,
										n3
											);
}

void draw_3d()
{
	draw_grid();		

	for (int i=0; i<MAX_SHAPES; i++)
	{
		shapes[i].update();
		
		if (shapes[i].active)
			shapes[i].render();
	}	
}


